package com.cirmuller.maidaddition.events;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.cirmuller.maidaddition.MaidPluginIn;
import com.cirmuller.maidaddition.entity.memory.CanChunkLoadedMemory;
import com.cirmuller.maidaddition.network.MaidChunkLoadingMessage;
import com.cirmuller.maidaddition.network.NetWorkHandler;
import com.github.tartaricacid.touhoulittlemaid.api.event.client.MaidContainerGuiEvent;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import java.lang.reflect.Field;
import java.util.List;
import net.minecraft.client.gui.Font;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.AbstractWidget;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;

@OnlyIn(Dist.CLIENT)
@EventBusSubscriber({Dist.CLIENT})
public class onMaidOpenGuiHandler {
  private static final ResourceLocation chunkLoadedButtonResource = new ResourceLocation("maidaddition", "textures/gui/maid_gui_button.png");
  
  private static final String buttonName = "maidaddition.chunk_loading_button";
  
  @SubscribeEvent
  public static void onMaidOpenGui(MaidContainerGuiEvent.Init event) {
    EntityMaid maid = event.getGui().getMaid();
    int leftPos = event.getLeftPos();
    int topPos = event.getTopPos();
    ImageButton chunkLoadedButton = new ImageButton(leftPos + 8, topPos + 26, 9, 9, 0, 0, 10, chunkLoadedButtonResource, button -> {
          CanChunkLoadedMemory memory = (CanChunkLoadedMemory)maid.getData(MaidPluginIn.canChunkLoadedData);
          boolean isChunkLoaded = (memory != null) ? memory.canChunkLoaded().booleanValue() : false;
          if (!isChunkLoaded) {
            isChunkLoaded = true;
            NetWorkHandler.CHANNEL.sendToServer(new MaidChunkLoadingMessage(maid.m_19879_(), isChunkLoaded));
          } else {
            isChunkLoaded = false;
            NetWorkHandler.CHANNEL.sendToServer(new MaidChunkLoadingMessage(maid.m_19879_(), isChunkLoaded));
          } 
        });
    event.addButton("maidaddition.chunk_loading_button", (AbstractWidget)chunkLoadedButton);
  }
  
  @SubscribeEvent
  public static void onRenderTooltip(MaidContainerGuiEvent.Tooltip event) throws NoSuchFieldException, IllegalAccessException {
    AbstractWidget chunkLoadedButton = event.getButton("maidaddition.chunk_loading_button");
    EntityMaid maid = event.getGui().getMaid();
    GuiGraphics graphics = event.getGraphics();
    int mouseX = event.getMouseX();
    int mouseY = event.getMouseY();
    Class<Screen> abstractMaidContainerGuiClass = Screen.class;
    Field[] fields = abstractMaidContainerGuiClass.getDeclaredFields();
    Field fontField = null;
    for (int i = 0; i < fields.length; i++) {
      Field field = fields[i];
      field.setAccessible(true);
      if (field.getType().equals(Font.class)) {
        fontField = field;
        break;
      } 
    } 
    assert fontField != null;
    fontField.setAccessible(true);
    Font font = (Font)fontField.get(event.getGui());
    if (chunkLoadedButton.m_274382_()) {
      MutableComponent context;
      CanChunkLoadedMemory memory = (CanChunkLoadedMemory)maid.getData(MaidPluginIn.canChunkLoadedData);
      boolean isChunkLoaded = (memory != null) ? memory.canChunkLoaded().booleanValue() : false;
      if (isChunkLoaded) {
        context = Component.m_237113_("").m_7220_((Component)Component.m_237115_("tooltips.maidaddition.info.chunk_loading.true"));
      } else {
        context = Component.m_237113_("").m_7220_((Component)Component.m_237115_("tooltips.maidaddition.info.chunk_loading.false"));
      } 
      graphics.m_280666_(font, List.of(context), mouseX, mouseY);
    } 
  }
}
